// Borland C++ Builder
// Copyright (c) 1995, 1999 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'StatusLine.pas' rev: 5.00

#ifndef StatusLineHPP
#define StatusLineHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <ExtCtrls.hpp>	// Pascal unit
#include <Forms.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <ComCtrls.hpp>	// Pascal unit
#include <Controls.hpp>	// Pascal unit
#include <Messages.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Statusline
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TFormatDate { fdShort, fdFull };
#pragma option pop

#pragma option push -b-
enum TFormatTime { ftShort, ftFull };
#pragma option pop

#pragma option push -b-
enum TProgressTextStyle { isPercent, isCount };
#pragma option pop

#pragma option push -b-
enum TShowLockType { slText, slLed };
#pragma option pop

#pragma option push -b-
enum TStatPanelType { spText, spCapsLock, spNumLock, spScrollLock, spDateTime, spImage, spProgress, 
	spAppHint, spOwnerDraw, spLed, spTextEllipsis };
#pragma option pop

class DELPHICLASS TStatusLine;
class DELPHICLASS TStatPanel;
typedef void __fastcall (__closure *TMyDrawPanelEvent)(TStatusLine* StatusLine, TStatPanel* Panel, const 
	Windows::TRect &Rect);

typedef void __fastcall (__closure *TMyHintEvent)(TStatusLine* StatusLine, TStatPanel* Panel, AnsiString 
	&Hint);

class DELPHICLASS TProgressProps;
class PASCALIMPLEMENTATION TProgressProps : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	TStatPanel* FOwner;
	int FPosition;
	int FMin;
	int FMax;
	Graphics::TColor FColor;
	TProgressTextStyle FITextStyle;
	Graphics::TColor FTextColor;
	void __fastcall SetPosition(const int Value);
	void __fastcall SetMin(const int Value);
	void __fastcall SetMax(const int Value);
	void __fastcall SetTextStyle(const TProgressTextStyle Value);
	void __fastcall SetColor(const Graphics::TColor Value);
	void __fastcall SetTextColor(const Graphics::TColor Value);
	
public:
	__fastcall TProgressProps(TStatPanel* AOwner);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	__property TStatPanel* Owner = {read=FOwner};
	
__published:
	__property int Position = {read=FPosition, write=SetPosition, default=0};
	__property int Min = {read=FMin, write=SetMin, default=0};
	__property int Max = {read=FMax, write=SetMax, default=100};
	__property Graphics::TColor Color = {read=FColor, write=SetColor, default=8388608};
	__property Graphics::TColor TextColor = {read=FTextColor, write=SetTextColor, default=-2147483634};
		
	__property TProgressTextStyle ITextStyle = {read=FITextStyle, write=SetTextStyle, default=0};
public:
		
	#pragma option push -w-inl
	/* TPersistent.Destroy */ inline __fastcall virtual ~TProgressProps(void) { }
	#pragma option pop
	
};


class DELPHICLASS TDateTimeProps;
class PASCALIMPLEMENTATION TDateTimeProps : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	bool FShowDate;
	bool FShowTime;
	TFormatDate FFormatDate;
	TFormatTime FFormatTime;
	TStatPanel* FOwner;
	
public:
	__fastcall TDateTimeProps(TStatPanel* AOwner);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	__property TStatPanel* Owner = {read=FOwner};
	
__published:
	__property bool ShowDate = {read=FShowDate, write=FShowDate, default=1};
	__property bool ShowTime = {read=FShowTime, write=FShowTime, default=1};
	__property TFormatDate FormatDate = {read=FFormatDate, write=FFormatDate, default=0};
	__property TFormatTime FormatTime = {read=FFormatTime, write=FFormatTime, default=1};
public:
	#pragma option push -w-inl
	/* TPersistent.Destroy */ inline __fastcall virtual ~TDateTimeProps(void) { }
	#pragma option pop
	
};


class DELPHICLASS TImageProps;
class PASCALIMPLEMENTATION TImageProps : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	Graphics::TPicture* FImage;
	int FMargin;
	int FSpacing;
	TStatPanel* FOwner;
	void __fastcall SetImage(const Graphics::TPicture* Value);
	void __fastcall SetSpacing(int Value);
	void __fastcall SetMargin(int Value);
	DYNAMIC void __fastcall ImageChanged(System::TObject* Sender);
	
public:
	__fastcall TImageProps(TStatPanel* AOwner);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	__property TStatPanel* Owner = {read=FOwner};
	
__published:
	__property Graphics::TPicture* Image = {read=FImage, write=SetImage};
	__property int Spacing = {read=FSpacing, write=SetSpacing, default=5};
	__property int Margin = {read=FMargin, write=SetMargin, default=2};
public:
	#pragma option push -w-inl
	/* TPersistent.Destroy */ inline __fastcall virtual ~TImageProps(void) { }
	#pragma option pop
	
};


class PASCALIMPLEMENTATION TStatPanel : public Classes::TCollectionItem 
{
	typedef Classes::TCollectionItem inherited;
	
private:
	Graphics::TPicture* FLED1;
	Graphics::TPicture* FLED2;
	bool FKeyOn;
	TStatPanelType FPanelType;
	AnsiString FText;
	Comctrls::TDrawPanelEvent FOnDrawPanel;
	Classes::TNotifyEvent FOnClick;
	TProgressProps* FProgress;
	TDateTimeProps* FDateTimeProps;
	TImageProps* FImageProps;
	TShowLockType FShowLockType;
	bool FActiveLed;
	bool FEnabledText;
	AnsiString FHint;
	TMyHintEvent FOnHintText;
	void __fastcall SetPanelType(const TStatPanelType Val);
	Classes::TAlignment __fastcall GetAlignment(void);
	Comctrls::TStatusPanelBevel __fastcall GetBevel(void);
	int __fastcall GetWidth(void);
	void __fastcall SetAlignment(const Classes::TAlignment Value);
	void __fastcall SetEnabledText(const bool Value);
	void __fastcall SetBevel(const Comctrls::TStatusPanelBevel Value);
	void __fastcall SetText(const AnsiString Value);
	void __fastcall SetWidth(const int Value);
	TStatusLine* __fastcall GetStatusLine(void);
	AnsiString __fastcall GetHint(void);
	void __fastcall SetProgressProps(const TProgressProps* Value);
	void __fastcall SetDateTimeProps(const TDateTimeProps* Value);
	void __fastcall SetImageProps(const TImageProps* Value);
	Comctrls::TStatusPanel* __fastcall GetLinkedPanel(void);
	void __fastcall SetShowLockType(TShowLockType AValue);
	void __fastcall SetActiveLed(bool AValue);
	
protected:
	virtual void __fastcall SetIndex(int Value);
	virtual AnsiString __fastcall GetDisplayName(void);
	DYNAMIC void __fastcall UpdateDateTime(void);
	DYNAMIC void __fastcall ShowHint(System::TObject* Sender);
	DYNAMIC void __fastcall DrawPanel(const Windows::TRect &Rect);
	DYNAMIC void __fastcall DoHintText(AnsiString &HintText);
	DYNAMIC void __fastcall Redraw(Graphics::TCanvas* Canvas, const Windows::TRect &Dest);
	DYNAMIC void __fastcall DrawKeyLock(Graphics::TCanvas* Canvas, const Windows::TRect &R);
	DYNAMIC void __fastcall TextDraw(Graphics::TCanvas* Canvas, const Windows::TRect &R);
	DYNAMIC void __fastcall DrawImage(Graphics::TCanvas* Canvas, const Windows::TRect &R);
	DYNAMIC void __fastcall DrawLeds(Graphics::TCanvas* Canvas, const Windows::TRect &R);
	DYNAMIC void __fastcall DrawIndicator(Graphics::TCanvas* Canvas, const Windows::TRect &R);
	DYNAMIC void __fastcall Click(void);
	void __fastcall UpdateKeyboardHook(void);
	__property Comctrls::TStatusPanel* LinkedPanel = {read=GetLinkedPanel};
	
public:
	__fastcall virtual TStatPanel(Classes::TCollection* AOwner);
	__fastcall virtual ~TStatPanel(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	void __fastcall Invalidate(void);
	__property TStatusLine* StatusLine = {read=GetStatusLine};
	__property AnsiString Hint = {read=GetHint, write=FHint};
	__property TMyHintEvent OnHintText = {read=FOnHintText, write=FOnHintText};
	
__published:
	__property bool ActiveLed = {read=FActiveLed, write=SetActiveLed, default=0};
	__property TProgressProps* ProgressProps = {read=FProgress, write=SetProgressProps};
	__property TDateTimeProps* DateTimeProps = {read=FDateTimeProps, write=SetDateTimeProps};
	__property TImageProps* ImageProps = {read=FImageProps, write=SetImageProps};
	__property bool EnabledText = {read=FEnabledText, write=SetEnabledText, nodefault};
	__property Classes::TAlignment Alignment = {read=GetAlignment, write=SetAlignment, default=0};
	__property Comctrls::TStatusPanelBevel Bevel = {read=GetBevel, write=SetBevel, default=1};
	__property TStatPanelType PanelType = {read=FPanelType, write=SetPanelType, default=0};
	__property TShowLockType ShowLockType = {read=FShowLockType, write=SetShowLockType, default=0};
	__property AnsiString Text = {read=FText, write=SetText};
	__property int Width = {read=GetWidth, write=SetWidth, nodefault};
	__property Comctrls::TDrawPanelEvent OnDrawPanel = {read=FOnDrawPanel, write=FOnDrawPanel};
	__property Classes::TNotifyEvent OnClick = {read=FOnClick, write=FOnClick};
};


class DELPHICLASS TStatPanels;
class PASCALIMPLEMENTATION TStatPanels : public Classes::TCollection 
{
	typedef Classes::TCollection inherited;
	
private:
	Extctrls::TTimer* FTimer;
	Classes::TList* FTimers;
	TStatusLine* FStatusLine;
	TStatPanels* FListPanels;
	HIDESBASE TStatPanel* __fastcall GetItem(int Index);
	HIDESBASE void __fastcall SetItem(int Index, TStatPanel* Value);
	
protected:
	virtual void __fastcall Update(Classes::TCollectionItem* Item);
	DYNAMIC Classes::TPersistent* __fastcall GetOwner(void);
	void __fastcall SetsTimer(TStatPanel* Panel);
	void __fastcall KillTimer(TStatPanel* Panel);
	void __fastcall RunTimer(System::TObject* Sender);
	
public:
	__fastcall TStatPanels(TStatusLine* StatusLine, Comctrls::TStatusPanels* LinkedPanels);
	__fastcall virtual ~TStatPanels(void);
	HIDESBASE TStatPanel* __fastcall Add(void);
	__property TStatPanel* Items[int Index] = {read=GetItem, write=SetItem/*, default*/};
};


class PASCALIMPLEMENTATION TStatusLine : public Comctrls::TStatusBar 
{
	typedef Comctrls::TStatusBar inherited;
	
private:
	AnsiString FAbout;
	TStatPanels* FPanels;
	Classes::TList* FListWinHook;
	HDC FCanvasEx;
	HFONT FFontEx;
	HFONT FFontExOld;
	unsigned FKeyHookMsg;
	HIDESBASE void __fastcall SetPanels(const TStatPanels* Value);
	bool __fastcall AppActivate(Messages::TMessage &Message);
	MESSAGE void __fastcall WMRefreshLock(Messages::TMessage &Msg);
	HIDESBASE MESSAGE void __fastcall CMFontChanged(Messages::TMessage &Msg);
	HIDESBASE MESSAGE void __fastcall CMHintShow(Messages::TMessage &Msg);
	void __fastcall SetOnDrawPanel(const TMyDrawPanelEvent Value);
	TMyDrawPanelEvent __fastcall GetOnDrawPanel(void);
	void __fastcall SetFontEx(void);
	HIDESBASE MESSAGE void __fastcall WMDestroy(Messages::TWMNoParams &Msg);
	
protected:
	DYNAMIC void __fastcall DrawPanel(Comctrls::TStatusPanel* Panel, const Windows::TRect &Rect);
	virtual void __fastcall Loaded(void);
	virtual void __fastcall CreateWnd(void);
	virtual void __fastcall WndProc(Messages::TMessage &Msg);
	Windows::TRect __fastcall GetPanelRect(int Index);
	TStatPanel* __fastcall FindLinkedPanel(Comctrls::TStatusPanel* Panel);
	void __fastcall SetWinHook(TStatPanel* Panel);
	void __fastcall KillWinHook(TStatPanel* Panel);
	tagSIZE __fastcall GetTextEx(const AnsiString Text);
	DYNAMIC void __fastcall Click(void);
	HFONT __fastcall GetFontEx(HFONT Font);
	
public:
	__fastcall virtual TStatusLine(Classes::TComponent* AOwner);
	__fastcall virtual ~TStatusLine(void);
	void __fastcall InvalidatePanel(int Index);
	
__published:
	__property AnsiString About = {read=FAbout, write=FAbout};
	__property TStatPanels* Panels = {read=FPanels, write=SetPanels};
	__property TMyDrawPanelEvent OnDrawPanel = {read=GetOnDrawPanel, write=SetOnDrawPanel};
public:
	#pragma option push -w-inl
	/* TWinControl.CreateParented */ inline __fastcall TStatusLine(HWND ParentWindow) : Comctrls::TStatusBar(
		ParentWindow) { }
	#pragma option pop
	
};


//-- var, const, procedure ---------------------------------------------------
static const Word WM_REFRESHLOCK = 0x812c;
extern PACKAGE System::ResourceString _CapsLockTxt;
#define Statusline_CapsLockTxt System::LoadResourceString(&Statusline::_CapsLockTxt)
extern PACKAGE System::ResourceString _NumLockTxt;
#define Statusline_NumLockTxt System::LoadResourceString(&Statusline::_NumLockTxt)
extern PACKAGE System::ResourceString _ScrollLockTxt;
#define Statusline_ScrollLockTxt System::LoadResourceString(&Statusline::_ScrollLockTxt)

}	/* namespace Statusline */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Statusline;
#endif
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// StatusLine
